<script setup lang="ts">
import { ChevronLgRight, Download, ArrowDown } from 'slippers-ui/icons';
import type { BaseHero } from '@/types/base';
const icons = { Download, ArrowDown };
defineProps<BaseHero>();
</script>

<template>
  <section class="hero" :class="[{ 'has-image': image }, config?.theme, { 'has-logos': customerLogos }]">
    <SlpContainer>
      <SlpRow class="wrapper">
        <SlpColumn class="content">
          <CommonEyebrow v-if="eyebrow" v-bind="eyebrow" class="slp-mb-24" />
          <SlpTypography v-if="tagline" class="slp-mb-16" variant="heading5-bold" tag="p">{{ tagline }}</SlpTypography>
          <SlpTypography variant="heading1-bold" tag="h1">
            <span v-if="titleHighlight" class="hero__title-highlight">{{ titleHighlight }}</span>
            <span v-html="$md.render(title)" />
          </SlpTypography>
          <SlpTypography
            v-if="description"
            class="hero__description"
            tag="div"
            :variant="config?.typographyVariants?.description || 'body1'"
          >
            <div v-html="$md.render(description)"></div>
          </SlpTypography>
          <div v-if="primaryButton || secondaryButton" class="hero__buttons" role="group" aria-label="buttons">
            <SlpButton
              v-if="primaryButton"
              :href="primaryButton.config.href"
              variant="primary"
              class="button"
              :data-ga-name="primaryButton.config.dataGaName"
              :data-ga-location="primaryButton.config.dataGaLocation"
            >
              {{ primaryButton.text }}
              <SlpIcon
                v-if="primaryButton.config.icon"
                class="slp-ml-16 icon"
                :icon="icons[primaryButton.config.icon]"
                size="sm"
              />
            </SlpButton>
            <SlpButton
              v-if="secondaryButton"
              :href="secondaryButton.config.href"
              variant="secondary"
              class="button"
              :data-ga-name="secondaryButton.config.dataGaName"
              :data-ga-location="secondaryButton.config.dataGaLocation"
            >
              {{ secondaryButton.text }}
            </SlpButton>
            <SlpButton
              v-if="tertiaryButton"
              :href="tertiaryButton.config.href"
              variant="tertiary"
              class="button"
              :data-ga-name="tertiaryButton.config.dataGaName"
              :data-ga-location="tertiaryButton.config.dataGaLocation"
            >
              {{ tertiaryButton.text }}
              <SlpIcon :icon="ChevronLgRight" size="sm" />
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn v-if="image" cols="5" class="image" :class="image.config.theme">
          <img :src="image.config.src" :alt="image.altText" />
        </SlpColumn>
        <SlpColumn v-if="customerLogos?.logos.length" cols="12">
          <SlpColumn cols="8" size="md">
            <CommonCustomerLogos v-bind="customerLogos" class="hero__logos" />
          </SlpColumn>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <div v-if="config?.background === 'purple'" class="purple-background"></div>
  </section>
</template>

<style lang="scss" scoped>
.wrapper {
  gap: 32px;
  align-items: center;
}

.hero {
  padding: $spacing-64 0;
  position: relative;
  overflow-x: hidden;

  .wrapper {
    gap: 32px;
    align-items: center;

    @media (max-width: $breakpoint-md) {
      flex-wrap: wrap;
    }
  }

  &.dark {
    background-color: $color-surface-700;
    color: $color-text-50;
  }

  &__description:deep(p:not(:first-child)) {
    margin-top: $spacing-24;
  }

  .slp-btn-tertiary {
    color: $color-text-50;
  }

  &.has-image {
    .image {
      img {
        width: 100%;
      }
      &.wide {
        img {
          width: auto;
          max-width: unset;
          @media (max-width: $breakpoint-md) {
            display: none;
          }
        }
      }
    }

    .rounded {
      img {
        border-bottom-right-radius: 160px; // Do not change this value without UX approval. If a Figma file shows an image with a different border radius, double check with UX.
      }
    }
  }

  &:not(.has-image) {
    .content {
      width: 100%;
    }
  }

  &__title-highlight {
    display: block;
    background: linear-gradient(91.08deg, #fca326 -9.03%, #a686f2 27.88%, #a989f5 65.98%);
    background-clip: text;
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
  }

  .image img {
    max-width: 100%;
    height: auto;
    display: block;
  }

  &__description {
    margin-top: $spacing-24;

    &:deep(strong) {
      font-weight: $font-weight-bold;
    }
  }

  &__buttons {
    display: flex;
    gap: $spacing-4;
    margin-top: $spacing-24;

    @media (max-width: $breakpoint-sm) {
      flex-direction: column;
    }

    .button {
      @media (max-width: $breakpoint-sm) {
        justify-content: center;
        margin-top: $spacing-8;
      }
    }

    .slp-btn-tertiary {
      padding-left: $spacing-16;
    }
  }
  &.has-logos {
    padding-bottom: 0;
    margin-bottom: 32px;
  }
}

.purple-background {
  position: absolute;
  z-index: -1;
  right: 0;
  background-color: $color-surface-800;
  width: 35vw;
  height: 100%;
  top: 0;

  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.animated {
  opacity: 0;
  transform: translate3d(0, 50%, 0);
  animation: intro-reveal 0.9s ease-out 0.5s forwards;
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 50%, 0);
    opacity: 0;
  }
  to {
    transform: translate3d(0, 0, 0);
    opacity: 1;
  }
}

@media (prefers-reduced-motion: reduce) {
  .animated {
    animation: none;
    opacity: 1;
    transform: translate3d(0, 0, 0);
  }
}

.hero__logos {
  :deep(.customer-logos) {
    margin-bottom: 0;
    @media (min-width: $breakpoint-md) {
      margin: -24px 0 0 0;
    }
    .customer-logos__companies {
      a {
        min-width: 100px;
        width: 100px;
        display: flex;
        align-items: center;
        flex-grow: 0;
        img {
          filter: grayscale(1) brightness(0);
          mix-blend-mode: multiply;
        }
      }
    }
    .customer-logos__trusted-by {
      font-size: 16px !important;
      @media (max-width: $breakpoint-md) {
        flex: 1 0 100%;
        max-width: 100%;
      }
    }
  }
}
</style>
